# E-Arkiv

The **E-Arkiv** module is a powerful tool for enabling advanced archiving functionalities within a Drupal site.
This module offers a reliable framework for managing and storing archived content, making it an excellent choice for
organizations that require comprehensive archiving solutions.

This module has been developed with the goal of enabling Swedish government websites powered by Drupal to comply
with archiving laws for digital content.

## Requirements

To use the default `Drupal\earkiv\Plugin\earkiv\Archiver\HTTrackArchiver` plugin the command line tool `httrack` must be
installed on the server. Please see installation instructions on the [HTTrack website](https://www.httrack.com/).

### Local development using DDEV

To add the `httrack` command to your local DDEV environment add the below configuration to your `.ddev/config.yaml`.

```yaml
webimage_extra_packages: [httrack]
```

## Installation

Install as you would normally install a contributed Drupal module. For further information, see [Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).

## Configuration

Configure the module on the E-Arkiv configuration page (/admin/config/services/earkiv).

1. Select the *Default archiver* plugin to use
2. Select the *Default storage* plugin to use

When the above steps are completed, click *Save*. After you have saved the configuration you will be presented with
additional configuration options for the selected plugins.

## Plugins

The module ships with two plugins. The *HTTrack* archiver plugin and the *Local* storage plugin. For simple use cases
these will be enough. If the site you are archiving is very large, or perhaps you like to store your archives offsite,
you can easily develop your own plugins.

For inspiration look at the included plugins at:

* `Drupal\earkiv\Plugin\earkiv\Archiver\HTTrackArchiver`
* `Drupal\earkiv\Plugin\earkiv\Storage\LocalStorage`

## Todo

Task that needs to be completed before a first release.

* [ ] Implement logic for creating archives based on the `Drupal\earkiv\entity\Schedule` entity

Tasks that can be completed at a later date.

* [ ] Think about how we can improve feedback during the archiving run
* [ ] Implement logic for HTTrack resume an aborted process
* [ ] Refactor entity delete forms, they are almost identical

## Shout-out

This module was inspired by the article [Sending a Drupal Site Into Retirement Using HTTrack](https://www.lullabot.com/articles/sending-drupal-site-retirement-using-httrack)
by [KarenS](https://www.drupal.org/u/karens).
