<?php

namespace Drupal\earkiv\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines an Archiver annotation object.
 *
 * @see \Drupal\earkiv\StoragePluginManager
 * @see plugin_api
 *
 * @Annotation
 */
class Archiver extends Plugin {

  /**
   * The plugin ID.
   *
   * This is used in the backend to identify the archiver plugin, not used for parsing.
   *
   * @var string
   */
  public $id;

  /**
   * The human-readable name of the archiver plugin.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $label;

  /**
   * Additional administrative information about the archiver plugin.
   *
   * @var \Drupal\Core\Annotation\Translation
   *  (optional)
   * @ingroup plugin_translatable
   */
  public $description;

  /**
   * The name of the provider that owns the archiver plugin.
   *
   * @var string
   */
  public $provider;

}
