<?php

declare(strict_types=1);

namespace Drupal\earkiv;

use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Archive status enum.
 */
final class ArchiveStatusEnum {

  public const NEW = 0;
  public const RUNNING_ARCHIVE = 1;
  public const RESUME_ARCHIVE = 2;
  public const WAITING = 3;
  public const RUNNING_STORE = 4;
  public const RESUME_STORE = 5;
  public const ERROR = 6;
  public const DONE = 7;

  /**
   * Get status text.
   */
  public static function getStatusText(int $status): TranslatableMarkup {
    return match ($status) {
      0 => new TranslatableMarkup('New'),
      1 => new TranslatableMarkup('Creating archive'),
      2 => new TranslatableMarkup('Archive error, will resume'),
      3 => new TranslatableMarkup('Waiting'),
      4 => new TranslatableMarkup('Moving to storage'),
      5 => new TranslatableMarkup('Storage error, will resume'),
      6 => new TranslatableMarkup('Error'),
      7 => new TranslatableMarkup('Done'),
      default => new TranslatableMarkup('Unknown'),
    };
  }
}
