<?php

namespace Drupal\earkiv;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\earkiv\Annotation\Archiver;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * A plugin manager for archiver plugins.
 */
class ArchiverPluginManager extends DefaultPluginManager {

  /**
   * StoragePluginManager constructor.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/earkiv/Archiver', $namespaces, $module_handler, ArchiverInterface::class,Archiver::class);
    $this->alterInfo('earkiv_archiver_info');
    $this->setCacheBackend($cache_backend, 'earkiv_archiver_info');
  }

}
