<?php

declare(strict_types=1);

namespace Drupal\earkiv;

use Drupal\earkiv\Entity\Archive;

/**
 * Trait JobStatusTrait.
 *
 * Provides methods to determine the status of a job.
 */
trait JobStatusTrait {

  /**
   * Determine the next status for a job.
   */
  protected function setJobStatusErrorResume(Archive $entity): void {
    $status = match ((int)$entity->get('status')->value) {
      ArchiveStatusEnum::RUNNING_ARCHIVE => ArchiveStatusEnum::RESUME_ARCHIVE,
      ArchiveStatusEnum::RUNNING_STORE => ArchiveStatusEnum::RESUME_STORE,
      default => ArchiveStatusEnum::ERROR,
    };
    $retries = $entity->get('retries')->value + 1;
    $entity->set('retries', $retries);
    if ($retries > Archive::NUM_RESUME_ATTEMPTS) {
      $entity->set('status', ArchiveStatusEnum::ERROR);
    }
    else {
      $entity->set('status', $status);
    }
    $entity->save();
  }

}
