<?php

declare(strict_types=1);

namespace Drupal\earkiv;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Plugin\PluginFormInterface;
use Drupal\earkiv\Entity\Archive;
use Drush\Commands\DrushCommands;

/**
 * An interface for WebhookHandler plugins.
 */
interface StorageInterface extends ConfigurableInterface, PluginInspectionInterface, PluginFormInterface, ContainerFactoryPluginInterface {

  /**
   * Storage label.
   *
   * @return string
   *   The storage plugin label.
   */
  public function getLabel(): string;

  /**
   * Storage description.
   *
   * @return string
   *   The storage plugin description.
   */
  public function getDescription(): string;

  /**
   * Get the Drush commands class.
   *
   * @return NULL|DrushCommands
   *    The Drush commands class.
   */
  public function getDrushCommands(): NULL|DrushCommands;

}
