<?php

namespace Drupal\earkiv;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\earkiv\Annotation\Storage;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * A plugin manager for storage plugins.
 */
class StoragePluginManager extends DefaultPluginManager {

  /**
   * StoragePluginManager constructor.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/earkiv/Storage', $namespaces, $module_handler, StorageInterface::class,Storage::class);
    $this->alterInfo('earkiv_storage_info');
    $this->setCacheBackend($cache_backend, 'earkiv_storage_info');
  }

}
